Index: core/gui.c
===================================================================
--- core/gui.c	(Revision 727)
+++ core/gui.c	(Arbeitskopie)
@@ -46,7 +46,7 @@
 //-------------------------------------------------------------------
 
 #define OPTIONS_AUTOSAVE
-#define SPLASH_TIME               20
+#define SPLASH_TIME               5 // XXX A configure option for this would be great
 
 int script_params_has_changed=0;
 //shortcuts
@@ -113,6 +113,11 @@
 // forward declarations
 //-------------------------------------------------------------------
 extern void dump_memory();
+// both from platform/generic/shooting.c
+extern const char* tv_override[];
+extern const int tv_override_amount;
+extern const int tv_override_zero_shift;
+	     
 
 static void gui_draw_osd();
 
@@ -156,6 +161,7 @@
 static void gui_menuproc_edge_free(int arg);
 #ifdef OPT_DEBUGGING
 void gui_compare_props(int arg);
+void gui_compare_params(int arg);
 #endif
 #ifndef OPTIONS_AUTOSAVE
 static void gui_menuproc_save(int arg);
@@ -422,6 +428,8 @@
     {0x2a,LANG_MENU_MAIN_DEBUG,              MENUITEM_SUBMENU,   (int*)&debug_submenu },
 #endif
     {0x86,LANG_MENU_REMOTE_PARAM,            MENUITEM_SUBMENU,   (int*)&remote_submenu },
+    {0x80,LANG_XXX_PROPCOMPARE,        MENUITEM_PROC,    (int*)gui_compare_props},
+    {0x80,LANG_XXX_PARAMCOMPARE,        MENUITEM_PROC,   (int*)gui_compare_params},
 #if defined (DNG_EXT_FROM)
     {0x71,LANG_MENU_DNG_VIA_USB,        MENUITEM_BOOL | MENUITEM_ARG_CALLBACK, &conf.dng_usb_ext , (int)cb_change_dng_usb_ext},
 #endif
@@ -993,7 +1001,7 @@
     conf.curve_enable+=change;
     if (conf.curve_enable<0)
         conf.curve_enable=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.curve_enable>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.curve_enable>=(sizeof(modes)/sizeof(modes[0])))
         conf.curve_enable=0;
 
 	if(change)
@@ -1008,7 +1016,7 @@
     conf.script_startup+=change;
     if (conf.script_startup<0)
         conf.script_startup=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.script_startup>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.script_startup>=(sizeof(modes)/sizeof(modes[0])))
         conf.script_startup=0;
 
     return modes[conf.script_startup];
@@ -1025,7 +1033,7 @@
         conf.script_param_set += change;
         if (conf.script_param_set < 0)
             conf.script_param_set = (sizeof(modes)/sizeof(modes[0]))-1;
-        else if (conf.script_param_set >= (sizeof(modes)/sizeof(modes[0])))
+        else if ((unsigned)conf.script_param_set >= (sizeof(modes)/sizeof(modes[0])))
             conf.script_param_set=0;
 
         if (!load_params_values(conf.script_file, 1, 0))
@@ -1044,7 +1052,7 @@
     conf.override_disable+=change;
     if (conf.override_disable<0)
         conf.override_disable=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.override_disable>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.override_disable>=(sizeof(modes)/sizeof(modes[0])))
         conf.override_disable=0;
 
     return modes[conf.override_disable];
@@ -1057,7 +1065,7 @@
     conf.histo_mode+=change;
     if (conf.histo_mode<0)
         conf.histo_mode=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.histo_mode>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.histo_mode>=(sizeof(modes)/sizeof(modes[0])))
         conf.histo_mode=0;
 
     histogram_set_mode(conf.histo_mode);
@@ -1072,7 +1080,7 @@
     conf.show_temp+=change;
     if (conf.show_temp<0)
         conf.show_temp=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.show_temp>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.show_temp>=(sizeof(modes)/sizeof(modes[0])))
         conf.show_temp=0;
 
     return modes[conf.show_temp];
@@ -1085,7 +1093,7 @@
     conf.histo_layout+=change;
     if (conf.histo_layout<0)
         conf.histo_layout=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.histo_layout>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.histo_layout>=(sizeof(modes)/sizeof(modes[0])))
         conf.histo_layout=0;
 
     if (conf.histo_layout==OSD_HISTO_LAYOUT_Y || conf.histo_layout==OSD_HISTO_LAYOUT_Y_argb) {
@@ -1104,7 +1112,7 @@
     conf.font_cp+=change;
     if (conf.font_cp<0)
         conf.font_cp=(sizeof(fonts)/sizeof(fonts[0]))-1;
-    else if (conf.font_cp>=(sizeof(fonts)/sizeof(fonts[0])))
+    else if ((unsigned)conf.font_cp>=(sizeof(fonts)/sizeof(fonts[0])))
         conf.font_cp=0;
 
     if (change != 0) {
@@ -1169,7 +1177,7 @@
     conf.raw_nr+=change;
     if (conf.raw_nr<0)
         conf.raw_nr=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.raw_nr>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.raw_nr>=(sizeof(modes)/sizeof(modes[0])))
         conf.raw_nr=0;
 
     return modes[conf.raw_nr];
@@ -1183,7 +1191,7 @@
     conf.reader_codepage+=change;
     if (conf.reader_codepage<0)
         conf.reader_codepage=(sizeof(cps)/sizeof(cps[0]))-1;
-    else if (conf.reader_codepage>=(sizeof(cps)/sizeof(cps[0])))
+    else if ((unsigned)conf.reader_codepage>=(sizeof(cps)/sizeof(cps[0])))
         conf.reader_codepage=0;
 
     return cps[conf.reader_codepage];
@@ -1196,7 +1204,7 @@
     conf.autoiso_shutter+=change;
     if (conf.autoiso_shutter<0)
         conf.autoiso_shutter=(sizeof(shutter)/sizeof(shutter[0]))-1;
-    else if (conf.autoiso_shutter>=(sizeof(shutter)/sizeof(shutter[0])))
+    else if ((unsigned)conf.autoiso_shutter>=(sizeof(shutter)/sizeof(shutter[0])))
         conf.autoiso_shutter=0;
 
     return shutter[conf.autoiso_shutter];
@@ -1209,7 +1217,7 @@
     conf.zebra_mode+=change;
     if (conf.zebra_mode<0)
         conf.zebra_mode=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.zebra_mode>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.zebra_mode>=(sizeof(modes)/sizeof(modes[0])))
         conf.zebra_mode=0;
 
     return modes[conf.zebra_mode];
@@ -1222,7 +1230,7 @@
     conf.zebra_draw_osd+=change;
     if (conf.zebra_draw_osd<0)
         conf.zebra_draw_osd=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.zebra_draw_osd>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.zebra_draw_osd>=(sizeof(modes)/sizeof(modes[0])))
         conf.zebra_draw_osd=0;
 
     return modes[conf.zebra_draw_osd];
@@ -1235,7 +1243,7 @@
     conf.zoom_value+=change;
     if (conf.zoom_value<0)
         conf.zoom_value=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.zoom_value>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.zoom_value>=(sizeof(modes)/sizeof(modes[0])))
         conf.zoom_value=0;
 
     return modes[conf.zoom_value];
@@ -1247,7 +1255,7 @@
     conf.show_values+=change;
     if (conf.show_values<0)
         conf.show_values=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.show_values>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.show_values>=(sizeof(modes)/sizeof(modes[0])))
         conf.show_values=0;
 
     return modes[conf.show_values];
@@ -1259,7 +1267,7 @@
     conf.nd_filter_state+=change;
     if (conf.nd_filter_state<0)
         conf.nd_filter_state=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.nd_filter_state>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.nd_filter_state>=(sizeof(modes)/sizeof(modes[0])))
         conf.nd_filter_state=0;
 
     return modes[conf.nd_filter_state];
@@ -1273,7 +1281,7 @@
     conf.show_dof+=change;
     if (conf.show_dof<0)
         conf.show_dof=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.show_dof>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.show_dof>=(sizeof(modes)/sizeof(modes[0])))
         conf.show_dof=0;
 
     return modes[conf.show_dof];
@@ -1286,7 +1294,7 @@
     conf.show_histo+=change;
     if (conf.show_histo<0)
         conf.show_histo=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.show_histo>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.show_histo>=(sizeof(modes)/sizeof(modes[0])))
         conf.show_histo=0;
 
     return modes[conf.show_histo];
@@ -1298,7 +1306,7 @@
     conf.show_clock+=change;
     if (conf.show_clock<0)
         conf.show_clock=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.show_clock>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.show_clock>=(sizeof(modes)/sizeof(modes[0])))
         conf.show_clock=0;
 
     return modes[conf.show_clock];
@@ -1310,7 +1318,7 @@
     conf.hide_osd+=change;
     if (conf.hide_osd<0)
         conf.hide_osd=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.hide_osd>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.hide_osd>=(sizeof(modes)/sizeof(modes[0])))
         conf.hide_osd=0;
 
     return modes[conf.hide_osd];
@@ -1322,7 +1330,7 @@
     conf.clock_format+=change;
     if (conf.clock_format<0)
         conf.clock_format=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.clock_format>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.clock_format>=(sizeof(modes)/sizeof(modes[0])))
         conf.clock_format=0;
 
     return modes[conf.clock_format];
@@ -1334,7 +1342,7 @@
     conf.clock_indicator+=change;
     if (conf.clock_indicator<0)
         conf.clock_indicator=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.clock_indicator>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.clock_indicator>=(sizeof(modes)/sizeof(modes[0])))
         conf.clock_indicator=0;
 
     return modes[conf.clock_indicator];
@@ -1346,7 +1354,7 @@
     conf.clock_halfpress+=change;
     if (conf.clock_halfpress<0)
         conf.clock_halfpress=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.clock_halfpress>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.clock_halfpress>=(sizeof(modes)/sizeof(modes[0])))
         conf.clock_halfpress=0;
 
     return modes[conf.clock_halfpress];
@@ -1358,7 +1366,7 @@
     conf.space_bar_show+=change;
     if (conf.space_bar_show<0)
         conf.space_bar_show=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.space_bar_show>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.space_bar_show>=(sizeof(modes)/sizeof(modes[0])))
         conf.space_bar_show=0;
 
     return modes[conf.space_bar_show];
@@ -1370,7 +1378,7 @@
     conf.space_bar_size+=change;
     if (conf.space_bar_size<0)
         conf.space_bar_size=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.space_bar_size>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.space_bar_size>=(sizeof(modes)/sizeof(modes[0])))
         conf.space_bar_size=0;
 
     return modes[conf.space_bar_size];
@@ -1382,7 +1390,7 @@
     conf.space_bar_width+=change;
     if (conf.space_bar_width<0)
         conf.space_bar_width=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.space_bar_width>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.space_bar_width>=(sizeof(modes)/sizeof(modes[0])))
         conf.space_bar_width=0;
 
     return modes[conf.space_bar_width];
@@ -1394,7 +1402,7 @@
     conf.space_warn_type+=change;
     if (conf.space_warn_type<0)
         conf.space_warn_type=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.space_warn_type>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.space_warn_type>=(sizeof(modes)/sizeof(modes[0])))
         conf.space_warn_type=0;
 
     return modes[conf.space_warn_type];
@@ -1406,7 +1414,7 @@
      conf.show_movie_time+=change;
      if (conf.show_movie_time<0)
          conf.show_movie_time=(sizeof(modes)/sizeof(modes[0]))-1;
-     else if (conf.show_movie_time>=(sizeof(modes)/sizeof(modes[0])))
+     else if ((unsigned)conf.show_movie_time>=(sizeof(modes)/sizeof(modes[0])))
          conf.show_movie_time=0;
  
      return modes[conf.show_movie_time];
@@ -1463,7 +1471,7 @@
     conf.alt_prevent_shutdown+=change;
     if (conf.alt_prevent_shutdown<0)
         conf.alt_prevent_shutdown=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.alt_prevent_shutdown>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.alt_prevent_shutdown>=(sizeof(modes)/sizeof(modes[0])))
         conf.alt_prevent_shutdown=0;
 
     return modes[conf.alt_prevent_shutdown];
@@ -1473,7 +1481,7 @@
     conf.fast_ev_step+=change;
     if (conf.fast_ev_step<0)
         conf.fast_ev_step=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.fast_ev_step>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.fast_ev_step>=(sizeof(modes)/sizeof(modes[0])))
         conf.fast_ev_step=0;
     return modes[conf.fast_ev_step];
 }
@@ -1486,7 +1494,7 @@
     conf.video_mode+=change;
     if (conf.video_mode<0)
         conf.video_mode=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.video_mode>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.video_mode>=(sizeof(modes)/sizeof(modes[0])))
         conf.video_mode=0;
 
     return modes[conf.video_mode];
@@ -1513,7 +1521,7 @@
     conf.tv_bracket_value+=change;
     if (conf.tv_bracket_value<0)
         conf.tv_bracket_value=sizeof(modes)/sizeof(modes[0])-1;
-    else if (conf.tv_bracket_value>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.tv_bracket_value>=(sizeof(modes)/sizeof(modes[0])))
         conf.tv_bracket_value=0;
 
     return modes[conf.tv_bracket_value]; 
@@ -1525,7 +1533,7 @@
     conf.av_bracket_value+=change;
     if (conf.av_bracket_value<0)
         conf.av_bracket_value=sizeof(modes)/sizeof(modes[0])-1;
-    else if (conf.av_bracket_value>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.av_bracket_value>=(sizeof(modes)/sizeof(modes[0])))
         conf.av_bracket_value=0;
 
     return modes[conf.av_bracket_value]; 
@@ -1537,7 +1545,7 @@
     conf.subj_dist_bracket_koef+=change;
     if (conf.subj_dist_bracket_koef<0)
         conf.subj_dist_bracket_koef=sizeof(modes)/sizeof(modes[0])-1;
-    else if (conf.subj_dist_bracket_koef>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.subj_dist_bracket_koef>=(sizeof(modes)/sizeof(modes[0])))
         conf.subj_dist_bracket_koef=0;
     
     return modes[conf.subj_dist_bracket_koef]; 
@@ -1549,7 +1557,7 @@
     conf.iso_bracket_koef+=change;
     if (conf.iso_bracket_koef<0)
         conf.iso_bracket_koef=sizeof(modes)/sizeof(modes[0])-1;
-    else if (conf.iso_bracket_koef>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.iso_bracket_koef>=(sizeof(modes)/sizeof(modes[0])))
         conf.iso_bracket_koef=0;
     
     return modes[conf.iso_bracket_koef]; 
@@ -1561,7 +1569,7 @@
     conf.bracket_type+=change;
     if (conf.bracket_type<0)
         conf.bracket_type=0;
-    else if (conf.bracket_type>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.bracket_type>=(sizeof(modes)/sizeof(modes[0])))
         conf.bracket_type=sizeof(modes)/sizeof(modes[0])-1;
 
     return modes[conf.bracket_type]; 
@@ -1581,7 +1589,7 @@
    else {
     if (conf.tv_override_koef<0)
         conf.tv_override_koef=sizeof(modes)/sizeof(modes[0])-1;
-    else if (conf.tv_override_koef>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.tv_override_koef>=(sizeof(modes)/sizeof(modes[0])))
         conf.tv_override_koef=0;
     }
     
@@ -1589,17 +1597,23 @@
 }
 
 const char* gui_tv_override_value_enum(int change, int arg) {
-    static const char* modes[]={"64","50.8", "40.3", "32", "25.4","20","16", "12.7", "10","8", "6.3","5","4","3.2", "2.5","2", "1.6", "1.3", "1", "0.8", "0.6", "0.5", "0.4", "0.3", "1/4", "1/5", "1/6", "1/8", "1/10", "1/13", "1/15", "1/20", "1/25", "1/30", "1/40", "1/50", "1/60", "1/80", "1/100", "1/125", "1/160", "1/200", "1/250", "1/320", "1/400", "1/500", "1/640","1/800", "1/1000", "1/1250", "1/1600","1/2000","1/2500","1/3200","1/4000", "1/5000", "1/6400", "1/8000", "1/10000", "1/12500", "1/16000", "1/20000", "1/25000", "1/32000", "1/40000", "1/50000", "1/64000","1/80000", "1/100k"};
+	/*
+    static const char* modes[]={
+    // add very long time exposures as approximately powers of 2, adding 15 exposures
+    "2048","1625","1290","1024","812","645","512","406","322","256","203","161","128","101","80",
+		"64","50.8", "40.3", "32", "25.4","20","16", "12.7", "10","8", "6.3","5","4","3.2", "2.5","2", "1.6", "1.3", "1", "0.8", "0.6", "0.5", "0.4", "0.3", "1/4", "1/5", "1/6", "1/8", "1/10", "1/13", "1/15", "1/20", "1/25", "1/30", "1/40", "1/50", "1/60", "1/80", "1/100", "1/125", "1/160", "1/200", "1/250", "1/320", "1/400", "1/500", "1/640","1/800", "1/1000", "1/1250", "1/1600","1/2000","1/2500","1/3200","1/4000", "1/5000", "1/6400", "1/8000", "1/10000", "1/12500", "1/16000", "1/20000", "1/25000", "1/32000", "1/40000", "1/50000", "1/64000","1/80000", "1/100k"};
+		*/
     static char *buf;
 
+	// XXX This array above is redundant with platform/generic/shooting.c, this should be avoided!
     conf.tv_override_value+=change;
     if (conf.tv_enum_type) {
        if (conf.tv_override_value<0) {
-          conf.tv_override_value=sizeof(modes)/sizeof(modes[0])-1;
+          conf.tv_override_value=tv_override_amount-1;
         }
-       else if (conf.tv_override_value>=(sizeof(modes)/sizeof(modes[0])))
+       else if ((unsigned)conf.tv_override_value>=(tv_override_amount))
          conf.tv_override_value=0;
-       return modes[conf.tv_override_value]; 
+       return tv_override[conf.tv_override_value]; 
      }
      else 
       {
@@ -1620,12 +1634,12 @@
     conf.tv_enum_type+=change;
     if (conf.tv_enum_type<0)
         conf.tv_enum_type=sizeof(modes)/sizeof(modes[0])-1;
-    else if (conf.tv_enum_type>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.tv_enum_type>=(sizeof(modes)/sizeof(modes[0])))
         conf.tv_enum_type=0;
     if (change) {
       conf.tv_override_koef=6;	
 	  if (conf.tv_enum_type)  
-	     conf.tv_override_value=18; 
+	     conf.tv_override_value=tv_override_zero_shift;
 	  else conf.tv_override_value=1; 
       }
     return modes[conf.tv_enum_type]; 
@@ -1638,7 +1652,7 @@
     conf.iso_override_koef+=change;
     if (conf.iso_override_koef<0)
         conf.iso_override_koef=0;
-    else if (conf.iso_override_koef>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.iso_override_koef>=(sizeof(modes)/sizeof(modes[0])))
         conf.iso_override_koef=sizeof(modes)/sizeof(modes[0])-1;
     
     return modes[conf.iso_override_koef]; 
@@ -1662,7 +1676,7 @@
 
     conf.subj_dist_override_koef+=change;
     if (conf.subj_dist_override_koef<0) conf.subj_dist_override_koef=0;
-    else if (conf.subj_dist_override_koef>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.subj_dist_override_koef>=(sizeof(modes)/sizeof(modes[0])))
         conf.subj_dist_override_koef=sizeof(modes)/sizeof(modes[0])-1;
     
     return modes[conf.subj_dist_override_koef]; 
@@ -1761,7 +1775,7 @@
     conf.user_menu_enable+=change;
     if (conf.user_menu_enable<0)
         conf.user_menu_enable=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.user_menu_enable>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.user_menu_enable>=(sizeof(modes)/sizeof(modes[0])))
         conf.user_menu_enable=0;
 
     return modes[conf.user_menu_enable];
@@ -1772,7 +1786,7 @@
     static const int keys[]={0, KEY_SHOOT_HALF, KEY_SET }; 
     int i; 
  
-    for (i=0; i<sizeof(names)/sizeof(names[0]); ++i) { 
+    for (i=0; (unsigned)i<sizeof(names)/sizeof(names[0]); ++i) { 
         if (conf.video_af_key==keys[i]) { 
             break; 
         } 
@@ -1781,7 +1795,7 @@
     i+=change; 
     if (i<0) 
         i=(sizeof(names)/sizeof(names[0]))-1; 
-    else if (i>=(sizeof(names)/sizeof(names[0]))) 
+    else if ((unsigned)i>=(sizeof(names)/sizeof(names[0]))) 
         i=0; 
  
     conf.video_af_key = keys[i]; 
@@ -1793,7 +1807,7 @@
     conf.bad_pixel_removal+=change; 
     if (conf.bad_pixel_removal<0) 
         conf.bad_pixel_removal=(sizeof(modes)/sizeof(modes[0]))-1; 
-    else if (conf.bad_pixel_removal>=(sizeof(modes)/sizeof(modes[0]))) 
+    else if ((unsigned)conf.bad_pixel_removal>=(sizeof(modes)/sizeof(modes[0]))) 
         conf.bad_pixel_removal=0; 
  
     return lang_str(modes[conf.bad_pixel_removal]); 
@@ -1801,7 +1815,7 @@
  
 //-------------------------------------------------------------------
 void gui_update_script_submenu() {
-    register int p=0, i;
+    register unsigned int p=0, i;
 
     for (i=0; i<sizeof(script_submenu_items_top)/sizeof(script_submenu_items_top[0]); ++p, ++i) {
         script_submenu_items[p]=script_submenu_items_top[i];
@@ -1826,7 +1840,7 @@
  struct stat st;
  if (!filename) return;
  stat((char*)filename,&st);
- if (st.st_size!=hook_raw_size()) return;
+ if ((long)st.st_size!=hook_raw_size()) return;
  gui_mbox_init((int)"", LANG_RAW_DEVELOP_MESSAGE, MBOX_BTN_OK|MBOX_TEXT_CENTER, NULL);
  raw_prepare_develop((char*)filename);
 }
@@ -1896,7 +1910,7 @@
     conf.debug_shortcut_action += change;
     if (conf.debug_shortcut_action < 0) 
         conf.debug_shortcut_action = sizeof(modes)/sizeof(modes[0])-1;
-    else if (conf.debug_shortcut_action >= (sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.debug_shortcut_action >= (sizeof(modes)/sizeof(modes[0])))
         conf.debug_shortcut_action = 0;
     
     return modes[conf.debug_shortcut_action]; 
@@ -1908,7 +1922,7 @@
     conf.debug_display += change;
     if (conf.debug_display < 0) 
         conf.debug_display=sizeof(modes)/sizeof(modes[0])-1;
-    else if (conf.debug_display >= (sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.debug_display >= (sizeof(modes)/sizeof(modes[0])))
         conf.debug_display = 0;
     
     return modes[conf.debug_display]; 
@@ -1973,7 +1987,7 @@
 static volatile enum Gui_Mode gui_mode;
 static volatile int gui_restore;
 static volatile int gui_in_redraw;
-static int gui_splash, gui_splash_mode;
+static unsigned int gui_splash, gui_splash_mode;
 static char osd_buf[32];
 #ifdef OPTIONS_AUTOSAVE
 static Conf old_conf;
@@ -2750,7 +2764,8 @@
 
    {
 	static char sbuf[100];
-    int r,i, p, len;
+	unsigned len;
+    int r,i, p;
     if (conf.debug_display == DEBUG_DISPLAY_PROPS){
 
 	for (i=0;i<10;i++){
@@ -2964,7 +2979,7 @@
         "CHDK Firmware '" HDK_VERSION " " BUILD_NUMBER "'" , 
         "Build: " __DATE__ " " __TIME__ ,
         "Camera: " PLATFORM " - " PLATFORMSUB };
-    int i, l;
+	unsigned i, l;
     color cl = MAKE_COLOR(COLOR_RED, COLOR_WHITE);
 
     gui_splash_mode = (mode_get()&MODE_MASK);
@@ -2993,7 +3008,7 @@
       for(pos=0; pos<logo_size; pos++){
           char data = logo[pos];
           color c = color_lookup[(data>>5) & 0x07];
-          for(i=0; i<(data&0x1F)+1; i++){
+          for(i=0; i<(data&0x1FU)+1; i++){
               if (c!=0x00){
                   draw_pixel(offset_x+mx,offset_y+my,c);
               }
@@ -3285,7 +3300,7 @@
 	char buf[64];
 	int i;
 	int p;
-	int c;
+	int c = 0;
 
 
 	if( initialized )
@@ -3325,4 +3340,189 @@
 	initialized = 1;
 }
 
+#define NUM_params 256
+#define BLACKLIST_FILENAME "A/CHDK/DATA/BLACKLIST.PAR"
+static signed char *blacklist = 0;
+int shooting_get_param( int id )
+{
+	int r = 0;
+	int s = sizeof(r);
+	if( blacklist )
+	{
+		if( id < 0 || id >= NUM_params )
+		{
+			s = 0;
+		}
+		else
+		{
+			s = blacklist[id];
+		}
+	}
+	if( s )
+	{
+		get_parameter_data(id,&r,s);
+	}
+	return r;
+}
+
+void write_blacklist_file( const signed char* bl )
+{
+	int fd;
+	fd = open(BLACKLIST_FILENAME, O_RDWR|O_CREAT|O_TRUNC, 0777);
+	write(fd,bl,NUM_params);
+	close(fd);
+}
+
+void gui_compare_params(int arg)
+{
+	static int initialized = 0;
+	static int *params = 0;
+	char buf[64];
+	int i;
+	int p;
+	int c;
+	int fd;
+	int test = 0;
+
+	if( 0 == blacklist )
+	{ 
+		blacklist = malloc(NUM_params);
+		// blacklist creation/loading of next step wasn't done yet, lets have a look if...
+		// the file exists at all
+		struct stat s;
+		s.st_size = 0;
+
+		stat(BLACKLIST_FILENAME,&s);
+		if( s.st_size < NUM_params )
+		{ // either from another compile or broken in another way or not there or... well whatever
+			for(i = 0; i < NUM_params; ++i )
+			{ // initialize all to -8 meaning: not yet tested
+				blacklist[i] = -8;
+			}
+		}
+		else
+		{
+			// open and read the file
+			fd = open(BLACKLIST_FILENAME, O_RDONLY,0);
+			read(fd,blacklist,NUM_params);
+			close(fd);
+		}
+		/*
+		 * The following entries are possible with the said meaning in the
+		 * blacklist file:
+		 * -8 : This param has not yet been tested, you should do this
+		 * -4 : The last test was tried with reading 4 bytes and failed. Action to be taken: write 2
+		 * -2 : The last test was tried with reading 4 bytes and failed. Action to be taken: write 1
+		 * -1 : The last test was tried with reading 4 bytes and failed. Action to be taken: write 0
+		 *  0 : Not a single byte can ever be read from this location
+		 *  1 : Only ever read 1 byte from the location
+		 *  2 : Only ever read 2 bytes from the location
+		 *  4 : It is save to read 4 bytes from this location
+		 */
+		i = 0;
+		// skip all entries that have been tested already
+		while( i < NUM_params )
+		{
+			switch(blacklist[i])
+			{
+				case -8:
+					sprintf(buf,"Testing param %d read 1",i);
+					draw_string(16,16,buf,MAKE_COLOR(COLOR_BLACK,COLOR_YELLOW));
+					// need to test, so... note in the array
+					blacklist[i] = -1;
+					write_blacklist_file(blacklist);
+					get_parameter_data(i,&test,1);
+
+					sprintf(buf,"Testing param %d read 2",i);
+					draw_string(16,16,buf,MAKE_COLOR(COLOR_BLACK,COLOR_YELLOW));
+					// no crash? try more!
+					blacklist[i] = -2;
+					write_blacklist_file(blacklist);
+					get_parameter_data(i,&test,2);
+
+					sprintf(buf,"Testing param %d read 4",i);
+					draw_string(16,16,buf,MAKE_COLOR(COLOR_BLACK,COLOR_YELLOW));
+					// no crash? try more!
+					blacklist[i] = -4;
+					write_blacklist_file(blacklist);
+					get_parameter_data(i,&test,4);
+
+					sprintf(buf,"Testing param %d was successfull up to 4",i);
+					draw_string(16,16,buf,MAKE_COLOR(COLOR_BLACK,COLOR_YELLOW));
+					// still no crash? wow, nice
+					blacklist[i] = 4;
+					write_blacklist_file(blacklist);
+					break;
+				case -4: // last test failed, record this
+					blacklist[i] = 2;
+					break;
+				case -2: // last test failed, record this
+					blacklist[i] = 1;
+					break;
+				case -1: // last test failed, record this
+					blacklist[i] = 0;
+					break;
+				case 0:
+				case 1:
+				case 2:
+				case 4:
+				default:
+					// this one is safe...
+					break;
+			}
+			// advance to the next...
+			++i;
+		}
+		// we went here without any crashes, that means the blacklist is
+		// complete now
+		write_blacklist_file(blacklist);
+	}
+	if( 0 == params )
+	{
+		params = malloc(NUM_params * sizeof(int));
+	}
+
+	if( initialized )
+	{ // we have previous data set! do a comparison
+		c = 0;
+		for( i = 0; i < NUM_params; ++i )
+		{
+			p = shooting_get_param(i);
+			if( params[i] != p )
+			{
+				++c;
+				sprintf(buf,"%4d is %8d was %8d",i,p,params[i]);
+				draw_string(16,16*c,buf,MAKE_COLOR(COLOR_BLACK,COLOR_YELLOW));
+			}
+			params[i] = p;
+			if( c == 12 )
+			{
+				++c;
+				sprintf(buf,"%s","Waiting 10 Seconds");
+				draw_string(16,16*c,buf,MAKE_COLOR(COLOR_BLACK,COLOR_YELLOW));
+				msleep(10000);
+				c = 0;
+			}
+		}
+		++c;
+		sprintf(buf,"%s","Waiting 10 Seconds");
+		draw_string(16,16*c,buf,MAKE_COLOR(COLOR_BLACK,COLOR_YELLOW));
+		msleep(10000);
+	}
+	else
+	{
+		// no previous data was set so we save the data initially
+		for( i = 0; i < NUM_params; ++i )
+		{
+#if 0
+			sprintf(buf,"About to read %d",i);
+			draw_string(16,16,buf,MAKE_COLOR(COLOR_BLACK,COLOR_YELLOW));
+			msleep(1000);
 #endif
+			params[i] = shooting_get_param(i);
+		}
+	}
+	initialized = 1;
+}
+#endif
+// vim: tabstop=4 shiftwidth=4
Index: core/gui_mpopup.c
===================================================================
--- core/gui_mpopup.c	(Revision 727)
+++ core/gui_mpopup.c	(Arbeitskopie)
@@ -41,7 +41,7 @@
 
 //-------------------------------------------------------------------
 void gui_mpopup_init(const unsigned int flags, void (*on_select)(unsigned int actn)) {
-    int i;
+    unsigned int i;
 
     mpopup_actions_num = 0;
     for (i=0; i<ACTIONSNUM && mpopup_actions_num<MAX_ACTIONS; ++i) {
